var axios = require('axios');
var Cookies = require('js-cookie');

// Create an Axios Client with defaults

const client = axios.create({
  baseURL: 'https://api.zupage.com',
  timeout: 10000,
  crossDomain: true,
  headers: {
    Authorization: 'null'
  }
});

// Request Wrapper with default success/error actions

var api = function(options) {
  var onSuccess = function(response) {
    console.log('Request Successful!', response);
    return response.data;
  };

  var onError = function(error) {
    console.error('Request Failed:', error.config);

    if (error.response) {
      // Request was made but server responded with something other than 2xx
      console.error('Status:', error.response.status);
      console.error('Data:', error.response.data);
      console.error('Headers:', error.response.headers);
    } else {
      // Something else happened while setting up the request triggered the error
    }

    return Promise.reject(error.response || error.message);
  };

  return client(options)
    .then(onSuccess)
    .catch(onError);
};

module.exports = api;
