var api = require("./api");
var html2canvas = require("html2canvas");
var axios = require("axios");

// Posts

function getPost(postId) {
  return api({
    url: "/posts/" + postId,
    method: "GET"
  });
}

function getPageContactInfo(pageId) {
  return api({
    url: "/pages/" + pageId + "/contact",
    method: "GET"
  });
}

function getCurrentPost() {
  var url_string = window.location.href;
  var url = new URL(url_string);
  var postId = url.searchParams.get("post_id");
  var zupagePost = window.zupagePost;
  console.log("ZupagePost", zupagePost);

  if (zupagePost) return zupagePost;

  return api({
    url: "/posts/" + postId,
    method: "GET"
  }).then(function(response) {
    // window.addEventListener('message', function(e) {
    //   generatePreview(response.template_id, response.id);
    // });
    return response;
  });
}

function generatePreview(templateId, postId) {
  // console.log('Generating Preview!', postId);
  // const canvas = html2canvas(document.body, {
  //   useCORS: true,
  //   proxy: 'https://' + templateId + '.zupage.com/proxy'
  // }).then(function(canvas) {
  //   var image = canvas.toDataURL('image/jpeg');
  //
  //   // Convert to image file
  //   var file = dataURLtoFile(image, 'screenshot.jpeg');
  //   console.log(file);
  //   window.parent.postMessage(file, '*');
  // });
}

function dataURLtoFile(dataurl, filename) {
  var arr = dataurl.split(","),
    mime = arr[0].match(/:(.*?);/)[1],
    bstr = atob(arr[1]),
    n = bstr.length,
    u8arr = new Uint8Array(n);
  while (n--) {
    u8arr[n] = bstr.charCodeAt(n);
  }
  return new File([u8arr], filename, { type: mime });
}

var zupage = {
  getPost: getPost,
  getCurrentPost: getCurrentPost,
  getPageContactInfo: getPageContactInfo
};

module.exports = zupage;
